//api_bsde.c
char *bsdeGetString(int str);
void bsdeSRand(bsdeUInt seed);
void bsdeSRand2(bsdeUInt seed1, bsdeUInt seed2);
int bsdeNewWorld();
void bsdeBindWorld(int i);
void bsdeStepWorld(double dt);
double bsdeGetWorldAttrF(int var);
void bsdeSetWorldAttrF(int var, double val);
int bsdeGetWorldAttrI(int var);
void bsdeSetWorldAttrI(int var, int val);
void bsdeGetWorldAttrFV(int var, float *val, int n);
void bsdeSetWorldAttrFV(int var, float *val, int n);
void bsdeGetWorldAttrDV(int var, double *val, int n);
void bsdeSetWorldAttrDV(int var, double *val, int n);
int *bsdeGetTriggerArray();
int bsdeGetTriggerArrayPos();
void bsdeResetTriggerArray();
void bsdeSetTriggerArray(int *arr, int num);
int bsdeNewAABB(double mx, double my, double mz,double nx, double ny, double nz);
int bsdeNewOBB(double mx, double my, double mz,double nx, double ny, double nz);
int bsdeNewSphere(double radius);
int bsdeNewCylinder(double height, double radius);
int bsdeNewCappedCylinder(double height, double radius);
int bsdeNewPlane(double x, double y, double z, double d);
int bsdeNewHullF(float *norms, int n);
int bsdeNewHullD(double *norms, int n);
int bsdeNewTriMeshF(float *vecs, int *tris, int nv, int nt);
int bsdeNewTriMeshD(double *vecs, int *tris, int nv, int nt);
void bsdeDestroy(int obj);
void bsdeHide(int obj);
void bsdeUnhide(int obj);
double bsdeGetAttrF(int obj, int var);
void bsdeSetAttrF(int obj, int var, double val);
int bsdeGetAttrI(int obj, int var);
void bsdeSetAttrI(int obj, int var, int val);
void bsdeGetAttrFV(int obj, int var, float *val, int n);
void bsdeSetAttrFV(int obj, int var, float *val, int n);
void bsdeGetAttrDV(int obj, int var, double *val, int n);
void bsdeSetAttrDV(int obj, int var, double *val, int n);
void bsdeGetAttrIV(int obj, int var, int *val, int n);
void bsdeSetAttrIV(int obj, int var, int *val, int n);
int bsdeNewJoint(int type);
void bsdeBindJointSolids(int obj, int obja, int objb);
double bsdeGetJointAttrF(int obj, int var);
void bsdeSetJointAttrF(int obj, int var, double val);
int bsdeGetJointAttrI(int obj, int var);
void bsdeSetJointAttrI(int obj, int var, int val);
void bsdeGetJointAttrFV(int obj, int var, float *val, int n);
void bsdeSetJointAttrFV(int obj, int var, float *val, int n);
void bsdeGetJointAttrDV(int obj, int var, double *val, int n);
void bsdeSetJointAttrDV(int obj, int var, double *val, int n);
void bsdeBegin(int type);
int bsdeEnd();
void bsdeVertex3f(double x, double y, double z);
void bsdeVertex4f(double x, double y, double z, double w);
void bsdeVertex3d(double x, double y, double z);
void bsdeVertex4d(double x, double y, double z, double w);
void bsdeVertex3fv(float *v);
void bsdeVertex4fv(float *v);
void bsdeVertex3dv(double *v);
void bsdeVertex4dv(double *v);
void bsdeNormal3f(double x, double y, double z);
void bsdeNormal4f(double x, double y, double z, double w);
void bsdeNormal3d(double x, double y, double z);
void bsdeNormal4d(double x, double y, double z, double w);
void bsdeNormal3fv(float *v);
void bsdeNormal4fv(float *v);
void bsdeNormal3dv(double *v);
void bsdeNormal4dv(double *v);
void bsdeAttrI(int var, int val);
void bsdeAttrF(int var, double val);
void bsdeAttrIV(int var, int *val, int num);
void bsdeAttrFV(int var, float *val, int num);
void bsdeAttrDV(int var, double *val, int num);
