#include "bsde_internal.h"

void BSDE_Vec3F_ProjectPointOnPlane(float *d, float *v, float *z)
{
	float f;
	f=V3F_DOT(v, z);
	V3F_ADDSCALE(v, z, -f, d);
}

void BSDE_Vec3F_ProjectPointOnPlane2(float *d, float *v, float *z, float zn)
{
	float f;
	f=V3F_DOT(v, z)-zn;
	V3F_ADDSCALE(v, z, -f, d);
}

void BSDE_Vec3D_ProjectPointOnPlane(double *d, double *v, double *z)
{
	double f;
	f=V3F_DOT(v, z);
	V3F_ADDSCALE(v, z, -f, d);
}

void BSDE_Vec3D_ProjectPointOnPlane2(double *d, double *v, double *z, double zn)
{
	double f;
	f=V3F_DOT(v, z)-zn;
	V3F_ADDSCALE(v, z, -f, d);
}
