/*
more obb crap, solid_obb was getting pretty large

assertions:
I need more to check for edge/face collisions.
by this point, we know the objects are colliding, trying to reason about
best separating approach.

assertion, if objects are interpenetrating, then at least some of the edges
cross some of the faces.

the crossed faces can provide the normals, and the edges will provide the
contact point.
may need multiple contact points.

if a box is projected on a line, then the start and end are the respective
intersections? I doubt it.

thought: project line to local space, and do AABB clipping, for result,
project back.


thought for collision function:
make projection to local space;
check what edges collide with each face, making a contact per face.
*/

#include "bsde_internal.h"

#if 0
	int BSDE_SolidOBB2_CollideMultiContactI(
	BSDE_Solid *aobj, double *apos,
	BSDE_Solid *bobj, double *bpos,
	BSDE_Contact **lst)
{
	static int edges[24]={
	0, 1,  1, 2,  2, 3,  3, 0,
	4, 5,  5, 6,  6, 7,  7, 4,
	4, 0,  5, 1,  6, 2,  7, 3};
	double pts[8*3];
	double brpos[16], aipos[16], ext[4];
	double v[3], tv0[3], vo[3], nv[3];
	double *v0, *v1;
	double f, g, d0, d1;
	int i, j, k, l, n;

//	BSDE_PlaneD_TransformVectorT(bpos+0*4, apos, brpos+0*4);
//	BSDE_PlaneD_TransformVectorT(bpos+1*4, apos, brpos+1*4);
//	BSDE_PlaneD_TransformVectorT(bpos+2*4, apos, brpos+2*4);
//	BSDE_PlaneD_TransformPointNT(bpos+3*4, apos, brpos+3*4);

//	BSDE_MatND_Inverse(apos, aipos, 4);
	BSDE_Mat4D_InverseTransform(apos, aipos);
	BSDE_Mat4D_MatMult(bpos, aipos, brpos);

	for(i=0; i<8; i++)
	{
		v[0]=(i&1)?bobj->maxs[0]:bobj->mins[0];
		v[1]=(i&2)?bobj->maxs[1]:bobj->mins[1];
		v[2]=(i&4)?bobj->maxs[2]:bobj->mins[2];
		BSDE_PlaneD_TransformPoint(v, brpos, pts+i*3);
	}

	n=0;
	for(i=0; i<6; i++)
	{
		l=0;
		V3D_ZERO(vo);

		for(j=0; j<12; j++)
		{
			v0=pts+edges[j*2+0]*3;
			v1=pts+edges[j*2+1]*3;

			if(i>=3)
			{
				f=aobj->maxs[i-3];
				if((v0[i-3]<f)==(v1[i-3]<f))continue;
			}else
			{
				f=aobj->mins[i];
				if((v0[i]>f)==(v1[i]>f))continue;
			}

			V3D_SUB(v1, v0, v);
			V3D_NORMALIZE(v, v);
			V3D_ADDSCALE(v0, v,(f-v0[i%3])/v[i%3], tv0);

			if(tv0[(i+1)%3]<aobj->mins[(i+1)%3])continue;
			if(tv0[(i+1)%3]>aobj->maxs[(i+1)%3])continue;
			if(tv0[(i+2)%3]<aobj->mins[(i+2)%3])continue;
			if(tv0[(i+2)%3]>aobj->maxs[(i+2)%3])continue;

			V3D_ADD(vo, tv0, vo);
			l++;
		}

		if(l)
		{
//			printf("%p %p collide %d %d edges\n",
//				aobj, bobj, i, l);

			V3D_ZERO(tv0);
			tv0[i%3]=(i/3)?1:-1;
			BSDE_PlaneD_TransformVector(tv0, apos, nv);

			V3D_SCALE(vo, 1.0/l, tv0);
			BSDE_PlaneD_TransformPoint(tv0, apos, v);

			BSDE_SolidOBB_ObbPlaneExtents(
				aobj->mins, aobj->maxs, apos, nv, ext+0);
			BSDE_SolidOBB_ObbPlaneExtents(
				bobj->mins, bobj->maxs, bpos, nv, ext+2);
			d0=(ext[0]>ext[2])?ext[0]:ext[2];
			d1=(ext[1]<ext[3])?ext[1]:ext[3];
			f=d1-d0;

//			f=0;

			lst[n++]=BSDE_MakeContact(bobj, aobj, v, nv, f);
		}
	}
//	if(n)printf("\n");

	return(n);
}

	int BSDE_SolidOBB2_CollideMultiContact(
	BSDE_Solid *aobj, double *apos,
	BSDE_Solid *bobj, double *bpos,
	BSDE_Contact **lst)
{
	double v[3], nv[3], f;
	int i, j, n;

	i=BSDE_SolidOBB_CheckCollide(
		aobj->mins, aobj->maxs, apos,
		bobj->mins, bobj->maxs, bpos);
	if(!i)return(0);

	i=BSDE_SolidOBB2_CollideMultiContactI(aobj, apos, bobj, bpos, lst);
	j=BSDE_SolidOBB2_CollideMultiContactI(bobj, bpos, aobj, apos, lst+i);

	n=i+j;
	if(!n)
	{
		i=BSDE_SolidOBB_CollideContact(
			aobj->mins, aobj->maxs, apos,
			bobj->mins, bobj->maxs, bpos,
			v, nv, &f);
		if(i)lst[n++]=BSDE_MakeContact(aobj, bobj, v, nv, f);
	}

	return(n);
}
#endif

#if 1
int BSDE_SolidOBB2_CollideNormal(
	double *amins, double *amaxs, double *apos,
	double *bmins, double *bmaxs, double *bpos,
	double *norm, double *dist)
{
	double ext[4];
	double bn[4], v0[3], v1[3];
	double d0, d1, d, bd, f;
	int i, j;

	V3D_ZERO(bn);
	bd=99999999.0;

	for(i=0; i<3; i++)
	{
		BSDE_SolidOBB_ObbPlaneExtents(amins, amaxs, apos,
			apos+i*4, ext+0);
		BSDE_SolidOBB_ObbPlaneExtents(bmins, bmaxs, bpos,
			apos+i*4, ext+2);
		d0=(ext[0]>ext[2])?ext[0]:ext[2];
		d1=(ext[1]<ext[3])?ext[1]:ext[3];

		d=d1-d0;
		if(d<0)return(0);


		j=(V3D_DOT(apos+3*4, apos+i*4) >
			V3D_DOT(bpos+3*4, apos+i*4));
		if(d<bd)
		{
			V3D_SCALE(apos+i*4, j?1:-1, bn);
			bn[4]=j?amaxs[i]:amins[i];
			bd=d;
		}
	}

	for(i=0; i<3; i++)
	{
		BSDE_SolidOBB_ObbPlaneExtents(amins, amaxs, apos,
			bpos+i*4, ext+0);
		BSDE_SolidOBB_ObbPlaneExtents(bmins, bmaxs, bpos,
			bpos+i*4, ext+2);
		d0=(ext[0]>ext[2])?ext[0]:ext[2];
		d1=(ext[1]<ext[3])?ext[1]:ext[3];

		d=d1-d0;
		if(d<0)return(0);


		j=(V3D_DOT(apos+3*4, bpos+i*4) >
			V3D_DOT(bpos+3*4, bpos+i*4));
		if(d<bd)
		{
			V3D_SCALE(bpos+i*4, j?1:-1, bn);
			bn[4]=j?bmaxs[i]:bmins[i];
			bd=d;
		}
	}

	V4D_COPY(bn, norm);
	*dist=bd;
	return(1);
}
#endif

#if 1
int BSDE_SolidOBB2_CollideMultiContact(
	BSDE_World *world,
	BSDE_Solid *aobj, double *apos,
	BSDE_Solid *bobj, double *bpos,
	BSDE_Contact **lst)
{
	static int edges[24]={
	0, 1,  1, 2,  2, 3,  3, 0,
	4, 5,  5, 6,  6, 7,  7, 4,
	4, 0,  5, 1,  6, 2,  7, 3};
	double apts[8*3], bpts[8*3], ext[4];
	double v[3], tv0[3], nv[4];
	double *v0, *v1;
	double *amins, *amaxs, *bmins, *bmaxs;
	double f, g, d, fd, d0, d1;
	int i, j, k, l, n;

	amins=aobj->mins; amaxs=aobj->maxs;
	bmins=bobj->mins; bmaxs=bobj->maxs;

	i=BSDE_SolidOBB2_CollideNormal(
		amins, amaxs, apos, bmins, bmaxs, bpos, nv, &fd);
//	i=BSDE_SolidOBB2_CollideNormal(
//		bmins, bmaxs, bpos, amins, amaxs, apos, nv, &fd);
	if(!i)return(0);

//	printf("collide (%f %f %f %f) %f\n",
//		nv[0], nv[1], nv[2], nv[3], fd);

	for(i=0; i<8; i++)
	{
		v[0]=(i&1)?amaxs[0]:amins[0];
		v[1]=(i&2)?amaxs[1]:amins[1];
		v[2]=(i&4)?amaxs[2]:amins[2];
		BSDE_PlaneD_TransformPoint(v, apos, apts+i*3);

		v[0]=(i&1)?bmaxs[0]:bmins[0];
		v[1]=(i&2)?bmaxs[1]:bmins[1];
		v[2]=(i&4)?bmaxs[2]:bmins[2];
		BSDE_PlaneD_TransformPoint(v, bpos, bpts+i*3);
	}

	n=0;
	for(i=0; i<12; i++)
//	for(i=0; i<8; i++)
	{
#if 1
		v0=apts+edges[i*2+0]*3; v1=apts+edges[i*2+1]*3;
		f=V3D_NDOT(v0, nv); g=V3D_NDOT(v1, nv); d=(f<g)?f:g;
		if((f==g) || ((f<0) && (g<0)) || ((f>0) && (g>0)))
			continue;

		BSDE_PlaneD_LinePlaneIntersect(v0, v1, nv, tv0);
		BSDE_PlaneD_TransformPointNT(tv0, bpos, v);
		d=0;
#endif

//		V3D_COPY(apts+i*3, tv0);
//		BSDE_PlaneD_TransformPointNT(tv0, bpos, v);

		if((v[0]<bmins[0]) || (v[0]>bmaxs[0]))continue;
		if((v[1]<bmins[1]) || (v[1]>bmaxs[1]))continue;
		if((v[2]<bmins[2]) || (v[2]>bmaxs[2]))continue;

		lst[n++]=BSDE_MakeContact(world, aobj, bobj, tv0, nv, -d);
	}

	for(i=0; i<12; i++)
//	for(i=0; i<8; i++)
	{
#if 1
		v0=bpts+edges[i*2+0]*3; v1=bpts+edges[i*2+1]*3;
		f=V3D_NDOT(v0, nv); g=V3D_NDOT(v1, nv); d=(f<g)?f:g;
		if((f==g) || ((f<0) && (g<0)) || ((f>0) && (g>0)))
			continue;

		BSDE_PlaneD_LinePlaneIntersect(v0, v1, nv, tv0);
		BSDE_PlaneD_TransformPointNT(tv0, apos, v);
		d=0;
#endif

//		V3D_COPY(bpts+i*3, tv0);
//		BSDE_PlaneD_TransformPointNT(tv0, apos, v);

		if((v[0]<amins[0]) || (v[0]>amaxs[0]))continue;
		if((v[1]<amins[1]) || (v[1]>amaxs[1]))continue;
		if((v[2]<amins[2]) || (v[2]>amaxs[2]))continue;

		lst[n++]=BSDE_MakeContact(world, aobj, bobj, tv0, nv, -d);
	}

#if 1
	if(!n)
	{
//		printf("points problem\n");

		V3D_SCALEADDSCALE(apos+3*4, 0.5, bpos+3*4, 0.5, tv0);
		lst[n++]=BSDE_MakeContact(world, aobj, bobj, tv0, nv, fd);

//		lst[n++]=BSDE_MakeContact(world, aobj, bobj, apos+3*4, nv, fd);
//		lst[n++]=BSDE_MakeContact(world, aobj, bobj, bpos+3*4, nv, fd);
	}
#endif

//	if(n)printf("%d points\n", n);

	return(n);
}
#endif


//NOTE: from ODE, should probably either remove or put correct stuff here...

#if 0
void BSDE_SolidOBB2_dLineClosestApproach(
	double *pa, double *ua, double *pb, double *ub,
	double *alpha, double *beta)
{
	double p[3];
	double uaub, q1, q2, d;

	p[0]=pb[0] - pa[0];
	p[1]=pb[1] - pa[1];
	p[2]=pb[2] - pa[2];
	uaub=V3D_DOT(ua,ub);
	q1=V3D_DOT(ua,p);
	q2=-V3D_DOT(ub,p);
	d=1-uaub*uaub;
	if(d<=0.0001)
	{
		// @@@ this needs to be made more robust
		*alpha=0;
		*beta=0;
	}else
	{
		d=1.0/d;
		*alpha=(q1 + uaub*q2)*d;
		*beta=(uaub*q1 + q2)*d;
	}
}

static int BSDE_SolidOBB2_intersectRectQuad(
	double *h, double *p, double *ret)
{
	int nq=4,nr;
	double buffer[16];
	double *q, *r, *pq, *pr;
	int dir, sign;
	double *nextq;
	int i;

	q=p; r=ret; pq=q; pr=r;

	for(dir=0; dir <=1; dir++)
	{
		for(sign=-1; sign <=1; sign +=2)
		{
			nr=0;
			for(i=nq; i>0; i--)
			{
				if(sign*pq[dir]<h[dir]) {
				pr[0]=pq[0];
				pr[1]=pq[1];
				pr +=2;
				nr++;
				if(nr & 8) {
					q=r;
					goto done;
			}
		}
		nextq=(i>1) ? pq+2 : q;
	if((sign*pq[dir]<h[dir]) ^(sign*nextq[dir]<h[dir])) {
		// this line crosses the chopping line
		pr[1-dir]=pq[1-dir] +(nextq[1-dir]-pq[1-dir]) /
			(nextq[dir]-pq[dir])*(sign*h[dir]-pq[dir]);
		pr[dir]=sign*h[dir];
		pr +=2;
		nr++;
		if(nr & 8) {
			q=r;
			goto done;
		}
	}
	pq +=2;
			}
			q=r;
			r=(q==ret) ? buffer : ret;
			nq=nr;
		}
	}
 done:
	if(q!=ret)memcpy(ret,q,nr*2*sizeof(double));
	return nr;
}


#define TST1(expr1,expr2,norm,cc) \
	s2=fabs(expr1)-(expr2); \
	if(s2>0) return 0; \
	if(s2>s)\
	{ \
		s=s2; \
		normalR=norm; \
		invert_normal=((expr1)<0); \
		code=(cc); \
	}

#define TST2(expr1,expr2,n1,n2,n3,cc) \
	s2=fabs(expr1)-(expr2); \
	if(s2>0) return 0; \
	l=sqrt((n1)*(n1) +(n2)*(n2) +(n3)*(n3)); \
	if(l>0) \
	{ \
		s2 /=l; \
		if(s2*fudge_factor>s) \
		{ \
			s=s2; \
			normalR=0; \
			normalC[0]=(n1)/l; \
			normalC[1]=(n2)/l; \
			normalC[2]=(n3)/l; \
			invert_normal=((expr1)<0); \
			code=(cc); \
		} \
	}

int BSDE_SolidOBB2_dBoxBox(
	BSDE_Solid *aobj, BSDE_Solid *bobj,

	double *p1, double *R1, double *side1,
	double *p2, double *R2, double *side2,
	double *normal, double *depth, int *return_code,
	BSDE_Contact **lst)
{
	double fudge_factor=1.05;
	double p[3], pp[3], normalC[3];
	double *normalR=0;
	double A[3],B[3],R11,R12,R13,R21,R22,R23,R31,R32,R33,
		Q11,Q12,Q13,Q21,Q22,Q23,Q31,Q32,Q33,s,s2,l;
	double pav[3], pbv[3];
	double ua[3],ub[3];
	double *Ra,*Rb,*pa,*pb,*Sa,*Sb;
	double normal2[3],nr[3],anr[3];
	double center[3];
	double quad[8];
	double c1,c2,m11,m12,m21,m22;
	double rect[2];
	double ret[16];
	double point[3*8];		// penetrating contact points
	double dep[8];			// depths for those points

	double sign;
	double alpha,beta;
	double k1, k2, k3, k4;
	double det1;
	double maxdepth;

	int iret[8];
	int i,j,invert_normal,code;
	int lanr,a1,a2;
	int codeN,code1,code2;
	int n;
	int cnum=0;
	int i1=0;

	pa=pav;
	pb=pbv;

	p[0]=p2[0] - p1[0];
	p[1]=p2[1] - p1[1];
	p[2]=p2[2] - p1[2];
	BSDE_PlaneD_TransformVectorT(p, R1, pp);

	A[0]=side1[0]*0.5;
	A[1]=side1[1]*0.5;
	A[2]=side1[2]*0.5;
	B[0]=side2[0]*0.5;
	B[1]=side2[1]*0.5;
	B[2]=side2[2]*0.5;

	R11=V3D_DOT44(R1+0,R2+0); R12=V3D_DOT44(R1+0,R2+1); R13=V3D_DOT44(R1+0,R2+2);
	R21=V3D_DOT44(R1+1,R2+0); R22=V3D_DOT44(R1+1,R2+1); R23=V3D_DOT44(R1+1,R2+2);
	R31=V3D_DOT44(R1+2,R2+0); R32=V3D_DOT44(R1+2,R2+1); R33=V3D_DOT44(R1+2,R2+2);

	Q11=fabs(R11); Q12=fabs(R12); Q13=fabs(R13);
	Q21=fabs(R21); Q22=fabs(R22); Q23=fabs(R23);
	Q31=fabs(R31); Q32=fabs(R32); Q33=fabs(R33);



	s=-999999999;
	invert_normal=0;
	code=0;

	// separating axis=u1,u2,u3
	TST1(pp[0],(A[0] + B[0]*Q11 + B[1]*Q12 + B[2]*Q13),R1+0,1);
	TST1(pp[1],(A[1] + B[0]*Q21 + B[1]*Q22 + B[2]*Q23),R1+1,2);
	TST1(pp[2],(A[2] + B[0]*Q31 + B[1]*Q32 + B[2]*Q33),R1+2,3);

	// separating axis=v1,v2,v3
	TST1(V3D_DOT41(R2+0,p),(A[0]*Q11 + A[1]*Q21 + A[2]*Q31 + B[0]),R2+0,4);
	TST1(V3D_DOT41(R2+1,p),(A[0]*Q12 + A[1]*Q22 + A[2]*Q32 + B[1]),R2+1,5);
	TST1(V3D_DOT41(R2+2,p),(A[0]*Q13 + A[1]*Q23 + A[2]*Q33 + B[2]),R2+2,6);

	// note: cross product axes need to be scaled when s is computed.
	// normal(n1,n2,n3) is relative to box 1.

#if 1
	// separating axis=u1 x(v1,v2,v3)
	TST2(pp[2]*R21-pp[1]*R31,(A[1]*Q31+A[2]*Q21+B[1]*Q13+B[2]*Q12),0,-R31,R21,7);
	TST2(pp[2]*R22-pp[1]*R32,(A[1]*Q32+A[2]*Q22+B[0]*Q13+B[2]*Q11),0,-R32,R22,8);
	TST2(pp[2]*R23-pp[1]*R33,(A[1]*Q33+A[2]*Q23+B[0]*Q12+B[1]*Q11),0,-R33,R23,9);

	// separating axis=u2 x(v1,v2,v3)
	TST2(pp[0]*R31-pp[2]*R11,(A[0]*Q31+A[2]*Q11+B[1]*Q23+B[2]*Q22),R31,0,-R11,10);
	TST2(pp[0]*R32-pp[2]*R12,(A[0]*Q32+A[2]*Q12+B[0]*Q23+B[2]*Q21),R32,0,-R12,11);
	TST2(pp[0]*R33-pp[2]*R13,(A[0]*Q33+A[2]*Q13+B[0]*Q22+B[1]*Q21),R33,0,-R13,12);

	// separating axis=u3 x(v1,v2,v3)
	TST2(pp[1]*R11-pp[0]*R21,(A[0]*Q21+A[1]*Q11+B[1]*Q33+B[2]*Q32),-R21,R11,0,13);
	TST2(pp[1]*R12-pp[0]*R22,(A[0]*Q22+A[1]*Q12+B[0]*Q33+B[2]*Q31),-R22,R12,0,14);
	TST2(pp[1]*R13-pp[0]*R23,(A[0]*Q23+A[1]*Q13+B[0]*Q32+B[1]*Q31),-R23,R13,0,15);
#endif

	if(!code)
	{
		printf("no axis\n");
		return 0;
	}
//	printf("have axis %d\n", code);

	// if we get to this point, the boxes interpenetrate. compute the normal
	// in global coordinates.
	if(normalR)
	{
		normal[0]=normalR[0];
		normal[1]=normalR[4];
		normal[2]=normalR[8];
	}else
	{
//		dMULTIPLY0_331(normal,R1,normalC);
		BSDE_PlaneD_TransformVector(normalC, R1, normal);
	}

	if(invert_normal)
	{
		normal[0]=-normal[0];
		normal[1]=-normal[1];
		normal[2]=-normal[2];
	}
	*depth=-s;

//	printf("%f %f %f %f\n", normal[0], normal[1], normal[2], *depth);

	// compute contact point(s)

	if(code>6)
	{
		// an edge from box 1 touches an edge from box 2.
		// find a point pa on the intersecting edge of box 1
		for(i=0; i<3; i++) pa[i]=p1[i];
		for(j=0; j<3; j++)
		{
			sign=(V3D_DOT14(normal,R1+j)>0)?1.0:-1.0;
			for(i=0; i<3; i++)pa[i]+=sign*A[j]*R1[i*4+j];
		}

// find a point pb on the intersecting edge of box 2
		for(i=0; i<3; i++) pb[i]=p2[i];
		for(j=0; j<3; j++)
		{
			sign=(V3D_DOT14(normal,R2+j)>0) ? -1.0 : 1.0;
			for(i=0; i<3; i++) pb[i] +=sign*B[j]*R2[i*4+j];
		}

		for(i=0; i<3; i++) ua[i]=R1[((code)-7)/3 + i*4];
		for(i=0; i<3; i++) ub[i]=R2[((code)-7)%3 + i*4];

		BSDE_SolidOBB2_dLineClosestApproach(
			pa,ua,pb,ub,&alpha,&beta);
		for(i=0; i<3; i++) pa[i] +=ua[i]*alpha;
		for(i=0; i<3; i++) pb[i] +=ub[i]*beta;

//		for(i=0; i<3; i++) contact[0].pos[i]=0.5*(pa[i]+pb[i]);
//		contact[0].depth=*depth;
		*return_code=code;

		V3D_SCALEADDSCALE(pa, 0.5, pb, 0.5, p);
		lst[0]=BSDE_MakeContact(aobj, bobj, p, normal, *depth);
		return 1;
	}

	if(code <=3)
	{
		Ra=R1;
		Rb=R2;
		pa=p1;
		pb=p2;
		Sa=A;
		Sb=B;

		normal2[0]=normal[0];
		normal2[1]=normal[1];
		normal2[2]=normal[2];
	}else
	{
		Ra=R2;
		Rb=R1;
		pa=p2;
		pb=p1;
		Sa=B;
		Sb=A;

		normal2[0]=-normal[0];
		normal2[1]=-normal[1];
		normal2[2]=-normal[2];
	}

	BSDE_PlaneD_TransformVectorT(normal2, Rb, nr);
	anr[0]=fabs(nr[0]);
	anr[1]=fabs(nr[1]);
	anr[2]=fabs(nr[2]);

	if(anr[1]>anr[0])
	{
		if(anr[1]>anr[2])
		{
			a1=0;
			lanr=1;
			a2=2;
		}else
		{
			a1=0;
			a2=1;
			lanr=2;
		}
	}else
	{
		if(anr[0]>anr[2])
		{
			lanr=0;
			a1=1;
			a2=2;
		} else
		{
			a1=0;
			a2=1;
			lanr=2;
		}
	}

	if(nr[lanr]<0)
	{
		for(i=0; i<3; i++)
			center[i]=pb[i] - pa[i] + Sb[lanr]*Rb[i*4+lanr];
	}else
	{
		for(i=0; i<3; i++)
			center[i]=pb[i] - pa[i] - Sb[lanr]*Rb[i*4+lanr];
	}

	if(code <=3) codeN=code-1; else codeN=code-4;

	if(codeN==0)
	{
		code1=1;
		code2=2;
	}else if(codeN==1)
	{
		code1=0;
		code2=2;
	}else
	{
		code1=0;
		code2=1;
	}

	c1=V3D_DOT14(center,Ra+code1);
	c2=V3D_DOT14(center,Ra+code2);

	m11=V3D_DOT44(Ra+code1,Rb+a1);
	m12=V3D_DOT44(Ra+code1,Rb+a2);
	m21=V3D_DOT44(Ra+code2,Rb+a1);
	m22=V3D_DOT44(Ra+code2,Rb+a2);

	k1=m11*Sb[a1];
	k2=m21*Sb[a1];
	k3=m12*Sb[a2];
	k4=m22*Sb[a2];
	quad[0]=c1 - k1 - k3;
	quad[1]=c2 - k2 - k4;
	quad[2]=c1 - k1 + k3;
	quad[3]=c2 - k2 + k4;
	quad[4]=c1 + k1 + k3;
	quad[5]=c2 + k2 + k4;
	quad[6]=c1 + k1 - k3;
	quad[7]=c2 + k2 - k4;

	rect[0]=Sa[code1];
	rect[1]=Sa[code2];

	n=BSDE_SolidOBB2_intersectRectQuad(rect,quad,ret);
	if(n<1)
	{
		printf("no points\n");
		return 0;	// this should never happen
	}
//	printf("have points\n");

	det1=1.0/(m11*m22 - m12*m21);
	m11*=det1;
	m12*=det1;
	m21*=det1;
	m22*=det1;

	for(j=0; j<n; j++)
	{
		k1=m22*(ret[j*2]-c1) - m12*(ret[j*2+1]-c2);
		k2=-m21*(ret[j*2]-c1) + m11*(ret[j*2+1]-c2);
		for(i=0; i<3; i++) point[cnum*3+i]=
			center[i] + k1*Rb[i*4+a1] + k2*Rb[i*4+a2];
		dep[cnum]=Sa[codeN] - V3D_DOT(normal2,point+cnum*3);

		if(dep[cnum] >=0)
//		if(1)
		{
			ret[cnum*2]=ret[j*2];
			ret[cnum*2+1]=ret[j*2+1];
			cnum++;
		}
	}
	if(cnum<1)
	{
		printf("no contact points\n");
		return 0;	// this should never happen
	}
	printf("have contact points\n");

	for(j=0; j<cnum; j++)
	{
//		dContactGeom *con=CONTACT(contact,skip*j);
//		for(i=0; i<3; i++) con->pos[i]=point[j*3+i] + pa[i];
//		con->depth=dep[j];

		V3D_ADD(point+j*3, pa, p);
		lst[j]=BSDE_MakeContact(aobj, bobj, p, normal2, dep[j]);
	}

	*return_code=code;
	return cnum;
}

int BSDE_SolidOBB2_dBoxBox(
	BSDE_Solid *aobj, BSDE_Solid *bobj,

	double *p1, double *R1, double *side1,
	double *p2, double *R2, double *side2,
	double *normal, double *depth, int *return_code,
	BSDE_Contact **lst);

	int BSDE_SolidOBB2_CollideMultiContact(
	BSDE_Solid *aobj, double *apos,
	BSDE_Solid *bobj, double *bpos,
	BSDE_Contact **lst)
{
	double aside[3], bside[3];
	double arot[16], brot[16];
	double v[3], nv[3], f;
	int i, j, n;

	BSDE_Mat4D_Transpose(apos, arot);
	BSDE_Mat4D_Transpose(bpos, brot);

	V3D_SUB(aobj->maxs, aobj->mins, aside);
	V3D_SUB(bobj->maxs, bobj->mins, bside);
	i=BSDE_SolidOBB2_dBoxBox(aobj, bobj,
		apos+3*4, arot, aside,
		bpos+3*4, brot, bside,
		nv, &f, &j, lst);

	if(i)printf("obb %d contacts\n", i);

	return(i);
}
#endif
